package com.steerinfo.meterwork.meterworkhookmetertime.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.meterworkhookmetertime.model.PointDetailsVo;
import com.steerinfo.meterwork.meterworkhookmetertime.model.GroupTimeVo;
import com.steerinfo.meterwork.meterworkhookmetertime.model.MeterWorkHookMeterTime;
import com.steerinfo.meterwork.meterworkhookmetertime.service.IMeterWorkHookMeterTimeService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkHookMeterTime RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-12-03 03:36
 * 类描述
 * 修订历史：
 * 日期：2022-12-03
 * 作者：generator
 * 参考：
 * 描述：MeterWorkHookMeterTime RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkhookmetertimes")
public class MeterWorkHookMeterTimeController extends BaseRESTfulController {

    @Autowired
    IMeterWorkHookMeterTimeService meterWorkHookMeterTimeService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkhookmetertime:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkHookMeterTime> list = meterWorkHookMeterTimeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkhookmetertime:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkHookMeterTime> list = meterWorkHookMeterTimeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkHookMeterTime对象创建")
    @ApiImplicitParam(name = "meterWorkHookMeterTime", value = "详细实体meterWorkHookMeterTime", required = true, dataType = "MeterWorkHookMeterTime")
    //@RequiresPermissions("meterworkhookmetertime:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkHookMeterTime model){
        MeterWorkHookMeterTime meterWorkHookMeterTime = meterWorkHookMeterTimeService.add(model);
        return success(meterWorkHookMeterTime);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkhookmetertime:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkHookMeterTime meterWorkHookMeterTime = meterWorkHookMeterTimeService.getById(id);
        return success(meterWorkHookMeterTime);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkHookMeterTime信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkHookMeterTime", value = "详细实体meterWorkHookMeterTime", required = true, dataType = "MeterWorkHookMeterTime")
    })
    //@RequiresPermissions("meterworkhookmetertime:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkHookMeterTime model){
        model.setId(id);
        MeterWorkHookMeterTime meterWorkHookMeterTime = meterWorkHookMeterTimeService.modify(model);
        return success(meterWorkHookMeterTime);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkhookmetertime:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkHookMeterTimeService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取称点统计时间")
    @ApiImplicitParam(name = "meterWorkHookMeterTime", value = "详细实体meterWorkHookMeterTime", required = true, dataType = "MeterWorkHookMeterTime")
    @PostMapping(value = "/getGroupByTime")
    @Transactional
    public RESTfulResult getGroupByTime(@RequestBody(required = false) HashMap meterWorkHookMeterTime){
        try {
            List<GroupTimeVo> groupByTime = meterWorkHookMeterTimeService.getGroupByTime(meterWorkHookMeterTime);
            return success(groupByTime);
        }catch (Exception e){
            e.printStackTrace();
            return success(null,"操作失败");
        }
    }

    @ApiOperation(value="获取称点详情")
    @ApiImplicitParam(name = "meterWorkHookMeterTime", value = "详细实体meterWorkHookMeterTime", required = true, dataType = "MeterWorkHookMeterTime")
    @GetMapping(value = "/getPointDetails")
    @Transactional
    public RESTfulResult getPointDetails(@RequestParam HashMap models){
        try {
            //分页功能
            PageHelper.startPage(Integer.parseInt(models.get("pageNum").toString()),Integer.parseInt(models.get("pageSize").toString()));
            List<PointDetailsVo> pointDetails = meterWorkHookMeterTimeService.getPointDetails(models);
            PageList<PointDetailsVo> pageList=new PageList<>(pointDetails);
            return success(pageList);
        }catch (Exception e){
            e.printStackTrace();
            return success(null,"操作失败");
        }
    }
}
